import { Component, isDevMode} from '@angular/core';
import {LoginService} from './services/login.service';
import {Router} from '@angular/router';

// TODO: add multiple samples at once
// TODO: validation: DPT: filename
// TODO: filter by not completely filled/no measurements
// TODO: validation of samples
// TODO: centralize fetching of materials / templates, etc.
// TODO: PWA

// TODO: get rid of chart.js (+moment.js)

@Component({
  selector: 'app-root',
  templateUrl: './app.component.html',
  styleUrls: ['./app.component.scss']
})
export class AppComponent {

  bugReport = {do: '', work: ''};

  constructor(
    public loginService: LoginService,
    private router: Router
  ) {
  }

  get devMode() {
    return isDevMode();
  }

  logout() {
    this.loginService.logout();
    this.router.navigate(['/']);
  }

  bugReportContent() {
    return `mailto:lukas.veit@de.bosch.com?subject=Bug report&body=Thanks for sending the report! Your bug will be (hopefully) fixed soon.
%0D%0A%0D%0A--- REPORT DATA ---
%0D%0A%0D%0ATime: ${new Date().toString()}%0D%0A
URL: ${window.location}%0D%0A%0D%0AWhat did you do?%0D%0A${encodeURIComponent(this.bugReport.do)}
%0D%0A%0D%0AWhat did not work?%0D%0A${encodeURIComponent(this.bugReport.work)}%0D%0A%0D%0ABrowser:%0D%0A
%0D%0AappCodeName: ${navigator.appCodeName}
%0D%0AappVersion: ${navigator.appVersion}
%0D%0Alanguage: ${navigator.language}
%0D%0AonLine: ${navigator.onLine}
%0D%0Aoscpu: ${navigator.oscpu}
%0D%0Aplatform: ${navigator.platform}
%0D%0AuserAgent: ${navigator.userAgent}
%0D%0AinnerWidth: ${window.innerWidth}
%0D%0AinnerHeight: ${window.innerHeight}`;
  }

  closeBugReport(close) {
    setTimeout(() => close(), 1);
  }
}



